// definiere Klasse: Ball
class Ball {
  // Felder: Koordinaten, Richtung, Radius
  float dx,dy,x,y,r;
  
  // Konstruktor
  // Parameter: Koordinaten, Radius
  public Ball (float x, float y, float r) {
    // setze Koordinaten und Radius
    this.x = x;
    this.y = y;
    this.r = r;
    // zufällige Richtung (enthält die Geschwindigkeit)
    dx = random(-5,5);
    dy = random(-5,5);
  }
  
  // Methode zum Bewegen des Balls
  void move () {
    // addiere Richtung auf Position 
    x += dx;
    y += dy;
    
    // falls Außerhalb der rechten Seite 
    if (x+r>width) {
      // Position wird innerhalb der Grenzen gesetzt
      x = width-r;
      // Richtung wird umgekehrt 
      dx *= -1;
    }
    // falls linker Rand
    else if (x-r<0) {
      // Position wird innerhalb der Grenzen gesetzt
      x = r;
      // Richtung wird umgekehrt
      dx *= -1;
    }
    // falls untere Seite
    if (y+r>height) {
      // Position wird innerhalb der Grenzen gesetzt
      y = height-r;
      // Richtung wird umgekehrt
      dy *= -1;
    }
    // falls obere Seite
    else if (y-r<0) {
      // Position wird innerhalb der Grenzen gesetzt
      y = r;
      // Richtung wird umgekehrt
      dy *= -1;
    }
  }
  
  // zeichne Ball
  void plot () {
    ellipse(x,y,2*r,2*r);
  }
  
  // behandle Ball
  void handle () {
    // bewege Ball
    move();
    // zeichne Ball
    plot();
  }
  
  // Kollision zwischen diesem und einem anderen Ball
  // Parameter: ein anderer Ball
  void collision (Ball other) {
    // ist Distanz zwischen beiden Bällen kleiner als die Summe ihrer Radien
    if (sq(other.x-this.x)+sq(other.y-this.y)<sq(other.r+this.r)) {
      //tausche Richtungen der beiden Bälle
      float px = this.dx;
      float py = this.dy;
      this.dx = other.dx;
      this.dy = other.dy;
      other.dx = px;
      other.dy = py;
    }
    // sonst fülle weiterhin mit weiß
    else fill(255); 
  }
}

// deklariere Liste aller existierender Bälle
Ball[] balls;

void setup () {
  size(800,800);
  // initialisiere Liste mit vier Bällen
  balls = new Ball[] {
    new Ball(100,100,20),
    new Ball(300,100,30),
    new Ball(500,100,40),
    new Ball(700,100,50)
  };
}

void draw () {
  // fülle Hintergrund
  background(255);
  // behandle jeden Ball in der Liste
  for (int i=0; i<balls.length; i++) {
    balls[i].handle();
    // überprüfe diesen Ball für jeden in der Liste nachfolgenden aud Kollision
    for (int j=i+1; j<balls.length; j++) {
      balls[i].collision(balls[j]);
    }
  }
}